/*
 * xpw.x
 *
 * Privilege-separated password daemon protocol.
 *
 * Copyright (c) 2002 Dug Song <dugsong@monkey.org>
 */

#ifdef RPC_XDR
%#include <sys/param.h>
%#include <pwd.h>
%#include <stdio.h>
#endif

%#define _PATH_XPW_SOCK		"/var/run/xpw.unix"

enum xpw_type {
	XPW_REP_OK = 0,
	XPW_REP_ERR,
	XPW_REQ_PASSWD,
	XPW_REQ_CHPASS
};

struct xpw_req_passwd {
	string		oldpass<_PASSWORD_LEN>;
	string		newpass<_PASSWORD_LEN>;
};

struct xpw_req_chpass {
       	string		gecos<BUFSIZ>;
	string		shell<MAXPATHLEN>;
};

union xpw switch (xpw_type xpw_type) {
 case XPW_REP_OK:
 case XPW_REP_ERR:
	string		reply<BUFSIZ>;
 case XPW_REQ_PASSWD:
	xpw_req_passwd	passwd;
 case XPW_REQ_CHPASS:
	xpw_req_chpass	chpass;
 default:
	void;
};
%#define xpw_reply	xpw_u.reply
%#define xpw_oldpass	xpw_u.passwd.oldpass
%#define xpw_newpass	xpw_u.passwd.newpass
%#define xpw_gecos	xpw_u.chpass.gecos
%#define xpw_shell	xpw_u.chpass.shell
%
%int	xpw_call(struct xpw *req, struct xpw *rep);
%
%size_t	xpw_xdr_encode(struct xpw *src, void *dst, size_t len);
%size_t	xpw_xdr_decode(void *src, size_t len, struct xpw *dst);
%int	xpw_xdr_free(struct xpw *xpw);
