
#include <sys/types.h>
#include <sys/time.h>

#include <err.h>
#include <event.h>
#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <util.h>

#include "xpw.h"
#include "xpwd.h"

extern char	*__progname;

static void
usage(void)
{
	fprintf(stderr, "Usage: %s\n", __progname);
	exit(1);
}

int
main(int argc, char *argv[])
{
	struct xpwd_ctx ctx;
	
	if (argc != 1)
		usage();

	if (daemon(0, 0) < 0)
		err(1, "daemon");

	openlog(__progname, LOG_PID|LOG_NDELAY, LOG_AUTH);
	
	event_init();
	
	memset(&ctx, 0, sizeof(ctx));
	ctx.sockname = _PATH_XPW_SOCK;
	
	if (xpwd_open(&ctx) < 0) {
		syslog(LOG_ERR, "couldn't initialize daemon: %m");
		exit(1);
	}
	pidfile(__progname);
	
	syslog(LOG_INFO, "listening on %s", ctx.sockname);
	
	event_dispatch();
	
	syslog(LOG_ERR, "event_dispatch: %m");
	
	exit(1);
}
